# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Speech.V1.Model.PhraseSet do
  @moduledoc """
  Provides information to the recognizer that specifies how to process the request.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :phraseSets => list(GoogleApi.Speech.V1.Model.PhraseSet.t()) | nil,
          :phraseSetReferences => list(String.t()) | nil,
          :customClasses => any() | nil
        }

  field(:phraseSets, as: GoogleApi.Speech.V1.Model.PhraseSet, type: :list)
  field(:phraseSetReferences, type: :list)
  field(:customClasses)
end

defimpl Poison.Decoder, for: GoogleApi.Speech.V1.Model.PhraseSet do
  def decode(value, options) do
    GoogleApi.Speech.V1.Model.RecognitionConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Speech.V1.Model.PhraseSet do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
